
var dmActiveDownloads  = [];
var localDownloadLabel = "Downloads";
window.addEventListener("load", dminit, true);
//window.addEventListener('close', dmexit, true);

function dmNoOp()
{
  alert('Hello, world');
}

function toggleDownloadMgr(open, close)
{
  var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
                     .getService(Components.interfaces.nsIWindowWatcher);

  if (window != ww.activeWindow) return 1;

  //alert(ww.activeWindow.arguments[0]);

  var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  var winType = preferencesService.getIntPref("downloadmgr.windowType");

  // Open Download Manager as a side bar
  if (winType == 1) {
    if (open && close) toggleSidebar('viewDMSidebar');
    else if (open) toggleSidebar('viewDMSidebar',true);
  }

  // Open Download Manager as a tab
  else if (winType == 2) {
    var numTabs = gBrowser.mTabContainer.childNodes.length;
    var index = 0;
    var oldTab = getBrowser().selectedTab;

    if (oldTab.getAttribute('download') == 'true') {
	  if (getWebNavigation().currentURI.spec == "chrome://downloadmgr/content/downloadtab.xul") {
        if (close) BrowserCloseTabOrWindow();
        return 0;
      }
      else oldTab.removeAttribute('download');
    }

    var tempTab = null;
    while (index < numTabs) {
      tempTab = gBrowser.mTabContainer.childNodes[index];

      if (tempTab.getAttribute('download') == 'true') {
        if (tempTab.label == localDownloadLabel || tempTab.label == 'chrome://downloadmgr/content/downloadtab.xul') break;
        else {
          getBrowser().selectedTab = tempTab;
          var url = getWebNavigation().currentURI.spec;
          if (url == 'chrome://downloadmgr/content/downloadtab.xul') break;
          else tempTab.removeAttribute('download');
	    }
	  }
      else index = index+1;
    }

    // If no download tab is open, then create one
    if (open && index == numTabs) {
      var dmTab = gBrowser.addTab('chrome://downloadmgr/content/downloadtab.xul');
      dmTab.setAttribute('download', 'true');
      updateDMTab();

      if (!gPrefService.getBoolPref("downloadmgr.loadTabInBackground"))
        getBrowser().selectedTab = dmTab;
      else getBrowser().selectedTab = oldTab;
    }
    else if (close || !gPrefService.getBoolPref("downloadmgr.loadTabInBackground"))
	  getBrowser().selectedTab = tempTab;
	else getBrowser().selectedTab = oldTab;
  }

  // Open Download Manager as a window
  else {
    if (open) toOpenWindowByType('Download:Manager','chrome://mozapps/content/downloads/downloads.xul','chrome,dialog=no,resizable');
  }
  return 0;
//  }
}

// Updates the label and icon of the Download Manager tab
function updateDMTab()
{
  var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  var showIcon = preferencesService.getBoolPref("downloadmgr.tabBusyIcon");

  var numTabs = gBrowser.mTabContainer.childNodes.length;
  var index = 0;

  var tempTab = null;
  var dmTab = null;
  while (index < numTabs) {
    tempTab = gBrowser.mTabContainer.childNodes[index];

    if (tempTab.getAttribute('download') == 'true') {
      dmTab = tempTab;
      break;
    }
    else index = index+1;
  }

  if (dmTab) {
    if (dmActiveDownloads.length == 0) {
      dmTab.label = localDownloadLabel;
      dmTab.removeAttribute('dl_active');
    }
    else {
      if (showIcon) dmTab.setAttribute('dl_active', 'true');
      if (dmActiveDownloads.length == 1) dmTab.label = localDownloadLabel + " - 1 file remaining";
      else dmTab.label = localDownloadLabel + " - " + dmActiveDownloads.length + " files remaining";
    }
  }
}

// Clean-up function called when a download is finished
function dmCompleted(aDownload)
{
  try {
    // Remove the download from our book-keeping list and if the count
    // falls to zero, update the title here, since we won't be getting
    // any more progress notifications in which to do it.
    for (var i = 0; i < dmActiveDownloads.length; ++i) {
      if (dmActiveDownloads[i] == aDownload) {
        dmActiveDownloads.splice(i, 1);
        break;
      }
    }
  }
  catch (e) {
  }
  updateDMTab();
}

function dmWindowClose(count)
{
  if (count > 5) return;
  var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
  var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
  var dmWindow = windowManagerInterface.getMostRecentWindow("Download:Manager");

  if (!dmWindow) setTimeout('dmWindowClose(' + (count+1) + ')',100);
  else dmWindow.close();
}

// Automatically close the download manager
function dmAutoClose()
{
  // If files are still downloading, don't close the DM
  if (dmActiveDownloads.length > 0) return;
  // or if the user opened the DM, don't automatically close it
  //else if (window.opener && window.opener.location.href != window.location.href) return;

  var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  var winType = preferencesService.getIntPref("downloadmgr.windowType");

  // Close Download Manager in a side bar
  if (winType == 1) {
	var title = localDownloadLabel;
    var sidebarTitle = document.getElementById("sidebar-title");
    if (sidebarTitle.value == title) toggleSidebar('viewDMSidebar', false);
  }

  // Close Download Manager in a tab
  else if (winType == 2) {
    var numTabs = gBrowser.mTabContainer.childNodes.length;
    var index = 0;
    var oldTab = getBrowser().selectedTab;

    // Check if current tab is the DM
    if (getWebNavigation().currentURI.spec == "chrome://downloadmgr/content/downloadtab.xul") {
      if (!gPrefService.getBoolPref("downloadmgr.loadTabInBackground")) BrowserCloseTabOrWindow();
      return;
    }

    // Find and close the DM tab (if one is open)
    while (index < numTabs) {
      var tempTab = gBrowser.mTabContainer.childNodes[index];

      if (tempTab.getAttribute('download') == 'true') {
        getBrowser().selectedTab = tempTab;
		//if (getWebNavigation().currentURI.spec == "chrome://downloadmgr/content/downloadtab.xul") BrowserCloseTabOrWindow();
		BrowserCloseTabOrWindow();
		getBrowser().selectedTab = oldTab;
        return;
	  }
      else index = index+1;
    }

    // Return the user to their current tab
  //  getBrowser().selectedTab = oldTab;
  }
  // Close Download Manager is separate window
  else dmWindowClose(0);
}

function dmDelayedOpen()
{
  if (dmActiveDownloads.length > 0) {
    if(toggleDownloadMgr(true,false)) setTimeout('toggleDownloadMgr(true,false)',500);
  }
}

var dmDownloadObserver = {
  observe: function (aSubject, aTopic, aState)
  {
    var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    switch (aTopic) {
    case "dl-done":
      var dl = aSubject.QueryInterface(Components.interfaces.nsIDownload);
      dmCompleted(dl);

	  try {
	 	var close = pref.getBoolPref("downloadmgr.closeWhenDone");
	  } catch (e) {}

	  if (close != false) dmAutoClose();
      break;
    case "dl-failed":
    case "dl-cancel":
      var dl = aSubject.QueryInterface(Components.interfaces.nsIDownload);
      dmCompleted(dl);
      break;
    case "dl-start":
      // Add this download to the percentage average tally
      var dl = aSubject.QueryInterface(Components.interfaces.nsIDownload);
      dmActiveDownloads.push(dl);
	  try {
	 	var show = pref.getBoolPref("downloadmgr.showWhenStarting");
	  } catch (e) {}

      var delay = pref.getIntPref("browser.download.manager.openDelay");
	  if (show != false) setTimeout('dmDelayedOpen()',delay);
	  updateDMTab();
      break;
    case "xpinstall-download-started":
      //var windowArgs = aSubject.QueryInterface(Components.interfaces.nsISupportsArray);
      //var params = windowArgs.QueryElementAt(0, Components.interfaces.nsISupportsInterfacePointer);
      //params = params.data.QueryInterface(Components.interfaces.nsIDialogParamBlock);
      //var installObserver = windowArgs.QueryElementAt(1, Components.interfaces.nsISupportsInterfacePointer);
      //installObserver = installObserver.data.QueryInterface(Components.interfaces.nsIObserver);
      //XPInstallDownloadManager.addDownloads(params, installObserver);
      break;
    case "xpinstall-dialog-close":
      //if ("gDownloadManager" in window) {
      //  var mgr = gDownloadManager.QueryInterface(Components.interfaces.nsIXPInstallManagerUI);
      //  gCanAutoClose = mgr.hasActiveXPIOperations;
      //  autoClose();
      //}
      break;
    }
  }
};

function dminit()
{
  window.removeEventListener("load", dminit, true);

  // Handlers for events generated by the Download Manager (download events)
  var observerService = Components.classes["@mozilla.org/observer-service;1"]
                                  .getService(Components.interfaces.nsIObserverService);
  observerService.addObserver(dmDownloadObserver, "dl-done",   false);
  observerService.addObserver(dmDownloadObserver, "dl-cancel", false);
  observerService.addObserver(dmDownloadObserver, "dl-failed", false);
  observerService.addObserver(dmDownloadObserver, "dl-start",  false);
  //observerService.addObserver(dmDownloadObserver, "dl-progress",  false);
  //observerService.addObserver(dmDownloadObserver, "xpinstall-download-started", false);
  //observerService.addObserver(dmDownloadObserver, "xpinstall-dialog-close",     false);

  var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  try {
    pref.setBoolPref("browser.download.manager.showWhenStarting", false);
    pref.setBoolPref("browser.download.manager.closeWhenDone", false);

    if(!prefService.prefHasUserValue("downloadmgr.windowType"))
      prefService.setIntPref("downloadmgr.windowType", 0);

    if(!prefService.prefHasUserValue("downloadmgr.showWhenStarting"))
      prefService.setBoolPref("downloadmgr.showWhenStarting", true);

    if(!prefService.prefHasUserValue("downloadmgr.closeWhenDone"))
      prefService.setBoolPref("downloadmgr.closeWhenDone", false);

    if(!prefService.prefHasUserValue("downloadmgr.bottomToolBar"))
      prefService.setBoolPref("downloadmgr.bottomToolBar", false);

    if(!prefService.prefHasUserValue("downloadmgr.buttonDownload"))
      prefService.setBoolPref("downloadmgr.buttonDownload", true);

    if(!prefService.prefHasUserValue("downloadmgr.buttonLaunch"))
      prefService.setBoolPref("downloadmgr.buttonLaunch", true);

    if(!prefService.prefHasUserValue("downloadmgr.buttonShow"))
      prefService.setBoolPref("downloadmgr.buttonShow", true);

    if(!prefService.prefHasUserValue("downloadmgr.buttonClean"))
      prefService.setBoolPref("downloadmgr.buttonClean", true);

    if(!prefService.prefHasUserValue("downloadmgr.buttonOptions"))
      prefService.setBoolPref("downloadmgr.buttonOptions", true);

    if(!prefService.prefHasUserValue("downloadmgr.loadTabInBackground"))
      prefService.setBoolPref("downloadmgr.loadTabInBackground", true);

    if(!prefService.prefHasUserValue("downloadmgr.tabBusyIcon"))
      prefService.setBoolPref("downloadmgr.tabBusyIcon", true);

  } catch (e) {}
}

function dmexit(aEvent)
{
  var observerService = Components.classes["@mozilla.org/observer-service;1"]
                                  .getService(Components.interfaces.nsIObserverService);
  observerService.removeObserver(dmDownloadObserver, "dl-done");
  observerService.removeObserver(dmDownloadObserver, "dl-cancel");
  observerService.removeObserver(dmDownloadObserver, "dl-failed");
  observerService.removeObserver(dmDownloadObserver, "dl-start");
  //observerService.removeObserver(dmDownloadObserver, "xpinstall-download-started");
  //observerService.removeObserver(dmDownloadObserver, "xpinstall-dialog-close");
}
